//+------------------------------------------------------------------+
//|                                             x MY High Low v2.mq4 |
//+------------------------------------------------------------------+
#property copyright "cja for tsd"

#property indicator_chart_window
extern string  note1           ="Auto HiLo = 0 or input price";
extern double  High_Price      = 0;
extern double  Low_Price       = 0;
extern string  note2           ="15 = M15 - 60 = H1 - 1440 = Daily";
extern int     HiLo_TimeFrame  = 1440;
extern string  note3           ="1 = previous bar - 2 = 2 bars back";
extern int     BarsBack        = 1;
extern string  note4           ="Line style width & colors";
extern int     Line_style      = 2;
extern int     Line_width      = 0;
extern color   Hi_color        = Blue;
extern color   Lo_color        = Red;
extern string  note            = "turn on Alert = true; turn off = false";
extern bool    alertsOn        = true;
extern bool    alertsOnCurrent = true;
extern bool    alertsMessage   = true;
extern bool    alertsSound     = true;
extern bool    alertsEmail     = false;
extern string  soundFile       = "alert2.wav";


double magic;
double trend[];

int init()
{
      IndicatorBuffers(1); 
      SetIndexBuffer(0,trend); 
      magic = HiLo_TimeFrame+High_Price+Low_Price;
      
   return(0);
  }
 
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  
      ObjectDelete("MY_High"+magic);
      ObjectDelete("MY_Low"+magic);
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
   
      
      //
      //
      //
      //
      //
      
      for (int i=limit; i>=0; i--) 
      {
         double Hi_Price;
         double Lo_Price;
         Hi_Price=iHigh(NULL,HiLo_TimeFrame,BarsBack);
            HiLoLine("MY_High"+magic,0, Hi_Price,Hi_Price,Line_width,Line_style,Hi_color,true); 
  
         Lo_Price=iLow(NULL,HiLo_TimeFrame,BarsBack);
         HiLoLine("MY_Low"+magic,0, Lo_Price,Lo_Price,Line_width,Line_style,Lo_color,true); 
    
            
            trend[i] = 0;
            if (Close[i] > Hi_Price) trend[i] = 1;
            if (Close[i] < Lo_Price) trend[i] =-1;
       }
       
       //
       //
       //
       //
       //
      
       if (alertsOn)
       {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1) doAlert("Buy");
            if (trend[whichBar] == -1) doAlert("Sell");       
         }         
      }
 return(0);
 }
  
  void HiLoLine(string hl, int Window,double start, double end,double w, double s,color clr, bool delete)
  {
   if (delete) ObjectDelete(hl);
   if(ObjectFind(hl)!=0)
     {
   ObjectCreate(hl, OBJ_HLINE,  0,0,start,Time[0],end);
   ObjectSet(hl, OBJPROP_COLOR, clr);
   ObjectSet(hl,OBJPROP_BACK,true);
   ObjectSet(hl,OBJPROP_WIDTH,w);
   ObjectSet(hl,OBJPROP_STYLE,s);
     }
   else
   ObjectMove(hl,0,0,Time[0]);
  } 
  
  //------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," xMY High Low ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," xMY High Low "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}